/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-1
Name        : main.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-27v1.0
Description : Matrix erstellen
              Schreiben Sie die Funktion createMatrix(…), welche eine Matrix erzeugt und die
              Matrix mit einem vorgegebenen Werte initialisiert (der Wert wird als dritter
              Übergabeparameter übergeben).
==================================================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"

/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv) {

  // set number of rows, cols and the initialization value
  const int rows = 4;
  const int cols = 3;
  const int value = 3;
  
  // create 3x4 matrix with initialization value 3
  int **m = createMatrix(rows,cols,value);
  
  if(m != NULL) {
    // print matrix to standard output
    printMatrix(m, rows, cols);
    
    // free memory
    freeMatrix(m, rows);
  }    
    
    return (EXIT_SUCCESS);
}

