/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-2
Name        : main.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-27v1.0
Description : Entwurf einer Übung zum Thema Zeigerarithmetik
              Entwerfen Sie eine Übung analog der Aufgabe in Kapitel 3 wo Sie Zeigerarithmetik
              einsetzen.
==================================================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include "zeigerarithmetic.h"

/*
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{
  int field[SIZE][SIZE];
  int posX = 0;
  int posY = 0;
  char input;

  /* fill the entire field with zero */
  memset(field, 0, sizeof(field));

  /* set a one in the first field */
  field[posY][posX] = 1;

  /* loop until a 'x' has been pressed (see below) */
  do
  {
    /* clear the screen - this makes the "matrix" appear at the
       same position all the time (very nice ;-) ) */
    //system("cls");
    system("cmd.exe /c cls"); // Cygwin hack

    /* prompt */
    printf("Zug [w hoch, a links, s runter, " \
           "d rechts] eingeben; beenden mit x\n");

    /* print the entire field on the console */
    printField(&field[0][0]);

    /* wait until a key has been pressed */
    while (!isalnum(input = (char)getchar()));

    /* move the "one" in the field, according to input */
    move(&field[0][0], &posX, &posY, input);
  } while(input != 'x');

  /* exit */
	return(EXIT_SUCCESS);
}

