/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-2
Name        : zeigerarithmetic.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-27v1.0
Description : Matrix erstellen
              Schreiben Sie die Funktion createMatrix(…), welche eine Matrix erzeugt und die
              Matrix mit einem vorgegebenen Werte initialisiert (der Wert wird als dritter
              Übergabeparameter übergeben).
==================================================================================================*/
#include <stdio.h>
#include "zeigerarithmetic.h"

/* print the field */
void printField(const int *field)
{
  int row, col;

  /* newline */
  printf("\n");

  /* loop through all the rows */
  for(row = 0; row < SIZE; row++)
  {
    /* loop through all the columns */
    for(col = 0; col < SIZE; col++)
    {
      printf("%d ", *(field + row * SIZE + col));
    }
    printf("\n");
  }  
}


/* moves the "one" around */
void move(int *field, int *posX, int *posY, char in)
{
  /* overwrite the old position with zero */
  *(field + *posY * SIZE + *posX) = 0;
  
  /* calculate the new position */
  switch(in)
  {
    case 'w': 
    {
      (*posY)--;
    }
    break;

    case 'a':
    {
      (*posX)--;
    }
    break;
    
    case 's':
    {
      (*posY)++;
    }
    break;
    
    case 'd':
    {
      (*posX)++;
    }
    break;
    
    /* should not happen, normally :-) */
    default:
      return;
  }

  /* check each of the coordinates against upper / lower bounds */
  if(*posX < 0)
  {
    *posX = SIZE - 1;
  }

  if(*posX > SIZE - 1)
  {
    *posX = 0;
  }

  if(*posY < 0)
  {
    *posY = SIZE - 1;
  }

  if(*posY > SIZE - 1)
  {
    *posY = 0;
  }

  /* set the new position */
  *(field + *posY * SIZE + *posX) = 1;
}
