/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-4
Name        : sensorgrid.h
Author      : StalderJ
Version     : 2012-10-27v1.0
Description : Mehrdimensionales Array mit Druckmesswerten
==================================================================================================*/
#ifndef SENSORGRID_H
#define	SENSORGRID_H

/**
 * Defines the fraction.
 */
typedef enum fraction {
    Mega = 'M',
    Kilo = 'K',
    Zero = ' ',
    Milli = 'm',
    Mikro = '\xb5'
} fraction_t;

/**
 * Defines the data structure.
 */
typedef struct sensordata {
    float pressure;
    fraction_t frac;
} sdata_t;
 
/**
 * Creates a grid of sensor data containers.
 * @param grid Reference to the grid that will be filled.
 * @param x First Dimension of the grid.
 * @param y Second Dimensions of the grid.
 */
void createGrid(sdata_t ***grid, unsigned int x, unsigned int y);

/**
 * Displays the grid on console.
 * @param grid Reference to the grid.
 * @param x Size of the grid in x direction.
 * @param y Size of the grid in y direction.
 */
void displayGrid(sdata_t **grid, unsigned int x, unsigned int y);

/**
 * Writes a value to the grid at position [x,y].
 * @param grid Reference to the grid.
 * @param x X-Dimension parameter.
 * @param y Y-Dimension parameter.
 * @param val Measure value.
 */
void writeToGrid(sdata_t **grid, unsigned int x, unsigned int y, float val);

#endif	/* SENSORGRID_H */
